// JSON parser start ----------------------------------------------------------
//
// Below is the minified JSON parser from http://json.org/json2.js
// 2010-08-25, Public Domain 
// NO WARRANTY EXPRESSED OR IMPLIED. USE AT YOUR OWN RISK.
if(!this.JSON){this.JSON={};}
(function(){function f(n){return n<10?'0'+n:n;}
if(typeof Date.prototype.toJSON!=='function'){Date.prototype.toJSON=function(key){return isFinite(this.valueOf())?this.getUTCFullYear()+'-'+
f(this.getUTCMonth()+1)+'-'+
f(this.getUTCDate())+'T'+
f(this.getUTCHours())+':'+
f(this.getUTCMinutes())+':'+
f(this.getUTCSeconds())+'Z':null;};String.prototype.toJSON=Number.prototype.toJSON=Boolean.prototype.toJSON=function(key){return this.valueOf();};}
var cx=/[\u0000\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,escapable=/[\\\"\x00-\x1f\x7f-\x9f\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,gap,indent,meta={'\b':'\\b','\t':'\\t','\n':'\\n','\f':'\\f','\r':'\\r','"':'\\"','\\':'\\\\'},rep;function quote(string){escapable.lastIndex=0;return escapable.test(string)?'"'+string.replace(escapable,function(a){var c=meta[a];return typeof c==='string'?c:'\\u'+('0000'+a.charCodeAt(0).toString(16)).slice(-4);})+'"':'"'+string+'"';}
function str(key,holder){var i,k,v,length,mind=gap,partial,value=holder[key];if(value&&typeof value==='object'&&typeof value.toJSON==='function'){value=value.toJSON(key);}
if(typeof rep==='function'){value=rep.call(holder,key,value);}
switch(typeof value){case'string':return quote(value);case'number':return isFinite(value)?String(value):'null';case'boolean':case'null':return String(value);case'object':if(!value){return'null';}
gap+=indent;partial=[];if(Object.prototype.toString.apply(value)==='[object Array]'){length=value.length;for(i=0;i<length;i+=1){partial[i]=str(i,value)||'null';}
v=partial.length===0?'[]':gap?'[\n'+gap+
partial.join(',\n'+gap)+'\n'+
mind+']':'['+partial.join(',')+']';gap=mind;return v;}
if(rep&&typeof rep==='object'){length=rep.length;for(i=0;i<length;i+=1){k=rep[i];if(typeof k==='string'){v=str(k,value);if(v){partial.push(quote(k)+(gap?': ':':')+v);}}}}else{for(k in value){if(Object.hasOwnProperty.call(value,k)){v=str(k,value);if(v){partial.push(quote(k)+(gap?': ':':')+v);}}}}
v=partial.length===0?'{}':gap?'{\n'+gap+partial.join(',\n'+gap)+'\n'+
mind+'}':'{'+partial.join(',')+'}';gap=mind;return v;}}
if(typeof JSON.stringify!=='function'){JSON.stringify=function(value,replacer,space){var i;gap='';indent='';if(typeof space==='number'){for(i=0;i<space;i+=1){indent+=' ';}}else if(typeof space==='string'){indent=space;}
rep=replacer;if(replacer&&typeof replacer!=='function'&&(typeof replacer!=='object'||typeof replacer.length!=='number')){throw new Error('JSON.stringify');}
return str('',{'':value});};}
if(typeof JSON.parse!=='function'){JSON.parse=function(text,reviver){var j;function walk(holder,key){var k,v,value=holder[key];if(value&&typeof value==='object'){for(k in value){if(Object.hasOwnProperty.call(value,k)){v=walk(value,k);if(v!==undefined){value[k]=v;}else{delete value[k];}}}}
return reviver.call(holder,key,value);}
text=String(text);cx.lastIndex=0;if(cx.test(text)){text=text.replace(cx,function(a){return'\\u'+
('0000'+a.charCodeAt(0).toString(16)).slice(-4);});}
if(/^[\],:{}\s]*$/.test(text.replace(/\\(?:["\\\/bfnrt]|u[0-9a-fA-F]{4})/g,'@').replace(/"[^"\\\n\r]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g,']').replace(/(?:^|:|,)(?:\s*\[)+/g,''))){j=eval('('+text+')');return typeof reviver==='function'?walk({'':j},''):j;}
throw new SyntaxError('JSON.parse');};}}());
// JSON parser end ------------------------------------------------------------

var LOGFILE_NAME = "scene-responder.log";
var l = new Logger(LOGFILE_NAME);



if (raisedEvent.name == 'sceneresponder.add') 
{
    Property.load();
    l.logln("sceneresponder.add");
    
    var check = true;
    
    if (raisedEvent.parameter.sceneresponderactions === undefined) 
    {
        l.logln("ERROR: missing sceneresponderactions parameter!");
        check = false;
    }
    
    if (check) 
    {
        var params = {};
        
        params.name = raisedEvent.parameter.scenerespondername;
        params.trigger = raisedEvent.parameter.scenerespondertrigger;
        params.actions = raisedEvent.parameter.sceneresponderactions;
        params.duration = raisedEvent.parameter.sceneresponderduration;
        
        Property.setProperty("triggers/" + params.name + "/params", JSON.stringify(params));
        Property.setProperty("triggers/" + params.name + "/queueID", '');
        
        //set archive flags
        Property.setFlag("triggers/" + params.name + "/params", "ARCHIVE", true);
        Property.setFlag("triggers/" + params.name + "/queueID", "ARCHIVE", true);
        Property.setFlag("triggers/" + params.name, "ARCHIVE", true);
        Property.setFlag("triggers", "ARCHIVE", true);
        
        Property.store();
    }
}
else if (raisedEvent.name == 'sceneresponder.execute') 
{
    l.logln("sceneresponder.execute");
    
    var params = JSON.parse(Property.getProperty("triggers/" + raisedEvent.parameter.name + "/params"));
    var action_params = JSON.parse(params.actions);
    if (action_params.actions === undefined) 
    {
        l.logln("ERROR: missing event actions!");
    }
    else 
    {
        for (i = 0; i < action_params.actions.length; i++) 
        {
            var action = action_params.actions[i];
            if (action === undefined) 
            {
                l.logln("ERROR: received invalid action values!");
                break;
            }
            
            if (action.unit === 'scene') 
            {
                l.logln("Calling scene " + action.scene + " on zone " +
                action.zone +
                " for devices of group " +
                action.group);
                var s = getDevices().byZone(action.zone).byGroup(action.group);
                s.callScene(action.scene);
            }
            else if (action.unit === 'group') 
            {
                l.logln("Setting value " + action.value + " on zone " +
                action.zone +
                " for devices of group " +
                action.group);
                var s = getDevices().byZone(action.zone).byGroup(action.group);
                s.setValue(aciton.value);
                /*s.perform(function(dev)
                 {
                 dev.setValue(action.value);
                 });*/
            }
        }
    }
    //delete old queueID
    Property.setProperty("triggers/" + raisedEvent.parameter.name + "/queueID", '');
    Property.store();
}
else if (raisedEvent.name == 'callScene') 
{
    Property.load();
    
    var sceneID = raisedEvent.parameter.sceneID;
    var zoneID = raisedEvent.source.zoneID;
    var groupID = raisedEvent.source.groupID
    
    var node = Property.getNode('triggers');
    var children = node.getChildren();
    
    l.logln("scene called: " + sceneID + " from zone: " + zoneID);
    
    for (var i = 0; i < children.length; i++) 
    {
        var params = JSON.parse(children[i].getChild('params').getValue());
        if ((JSON.parse(params.trigger).scene == sceneID && JSON.parse(params.trigger).zone == zoneID && JSON.parse(params.trigger).group == groupID) || (groupID == 0 && zoneID == 0 && sceneID >= 64 && JSON.parse(params.trigger).scene == sceneID) || (groupID == 0 && sceneID >= 64 && JSON.parse(params.trigger).zone == zoneID && JSON.parse(params.trigger).scene == sceneID)) 
        {
            var queueID = children[i].getChild('queueID').getValue();
            if (queueID != undefined && queueID != '') 
            {
                //event is already in queue, so delete old event
                var queueNode = Property.getNode('/system/EventInterpreter/ScheduledEvents');
                queueNode.removeChild(queueID);
            }
            if (params.duration > 0) 
            {
                var timerEvent = new TimedEvent("sceneresponder.execute", '+' + params.duration * 60, //convert params.duration to seconds
                 {
                    name: params.name
                });
                children[i].getChild('queueID').setValue(timerEvent.raise());
            }
            else if (params.duration == 0) 
            {
                var nowEvent = new Event("sceneresponder.execute", 
                {
                    name: params.name
                });
                nowEvent.raise();
            }
        }
    }
}
else if (raisedEvent.name == 'sceneresponder.delete') 
{
    Property.load();
    
    l.logln("sceneresponder.delete");
    
    var node = Property.getNode('triggers');
    if (node.getChildren().length != null) 
    {
        //var children = node.getChildren();
        l.logln("remove " + raisedEvent.parameter.scenerespondername);
        
        //check if the an event is queued, if so delete it first
        if (node.getChild(raisedEvent.parameter.scenerespondername).getChild('queueID').getValue() != '') 
        {
            var queueNode = Property.getNode('/system/EventInterpreter/ScheduledEvents');
            queueNode.removeChild(node.getChild(raisedEvent.parameter.scenerespondername).getChild('queueID').getValue());
        }
        node.removeChild(raisedEvent.parameter.scenerespondername);
    }
    Property.store();
}
else if (raisedEvent.name == 'running') 
{
    l.logln("scene-responder running");
    Property.load();
    
    var triggers = new Property('triggers');
    triggers.setFlag('ARCHIVE', true);
    
    //check for version
    if (Property.getProperty('version') != '0.1.4') 
    {
        //update actions with default values
        var node = Property.getNode('triggers');
        var children = node.getChildren();
        l.logln('length: ' + children.length);
        for (var i = 0; i < children.length; i++) 
        {
            l.logln(children[i].getChild('params').getValue());
			var params = JSON.parse(children[i].getChild('params').getValue());
            var trigger = JSON.parse(params.trigger);
            
            if (trigger.group == undefined || trigger.group == '') 
            {
                //set default group 1 = light
				trigger.group = 1;
                l.logln('changing ' + params.name);
            }
            
            params.trigger = JSON.stringify(trigger);
            children[i].getChild('params').setValue(JSON.stringify(params));
            
        }
        
        //set new version number
        Property.setProperty('version', '0.1.4');
        Property.setFlag('version', 'ARCHIVE', true);
    }
	
	Property.store();
}
